package com.thaiopensource.trex;

import com.thaiopensource.datatype.Datatype;
import com.thaiopensource.datatype.DatatypeContext;

class StringAtom extends Atom {
  private String str;
  private String normStr;
  private DatatypeContext dc;

  StringAtom(String str, DatatypeContext dc) {
    this.str = str;
    this.dc = dc;
  }
 
  boolean matchesString() {
    return true;
  }

  boolean matchesPreserveString(String s) {
    return str.equals(s);
  }

  boolean matchesNormalizeString(String s) {
    if (normStr == null)
      normStr = StringNormalizer.normalize(str);
    return normStr.equals(s);
  }

  boolean matchesDatatype(Datatype dt) {
    return dt.allows(str, dc);
  }
  
  String getString() {
    return str;
  }
}
